diff --git a/src/backend/executor/execProcnode.c b/src/backend/executor/execProcnode.c
index b5667e53e5..d5e10756ac 100644
--- a/src/backend/executor/execProcnode.c
+++ b/src/backend/executor/execProcnode.c
@@ -123,6 +123,209 @@ static TupleTableSlot *ExecProcNodeFirst(PlanState *node);
 static TupleTableSlot *ExecProcNodeInstr(PlanState *node);
 
 
+/* ------------------------------------------------------------------------
+ * ExecPrepNode
+ *		Recursively "prep" all the nodes in the plan tree rooted
+ *		at 'node'.
+ *
+ *		'node' is the current node of the plan produced by the query planner
+ *		'context' is the information that may be necessary to do the prep
+ *			work, (such as any EXTERN parameters in the query to do partition
+ *			pruning with)
+ *		'result' is the output variable to add the result into
+ *
+ * NOTE: ExecPrepNode subroutine for a given node must add the RT indexes of
+ * any relations that it manipulates to result->relationRTIs.  Optionally, it
+ * can produce a PlanPrepOutput node containing the information that may be of
+ * interest to later execution steps or to any intervening modules that have
+ * access to the ExecPrepOutput and put that in
+ * result->planPrepResults[plan->plan_node_id].  For example, nodes that
+ * supports partition pruning can perform the "initial" pruning steps to
+ * produce the set of "initially valid" subnodes that can be used as-is by the
+ * node's ExecInit* routine to only initialize those subnodes.
+ * ------------------------------------------------------------------------
+ */
+void
+ExecPrepNode(Plan *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	ListCell *l;
+
+	/* Do nothing when we get to the end of a leaf on tree. */
+	if (node == NULL)
+		return;
+
+	/* Make sure there's enough stack available. */
+	check_stack_depth();
+
+	/*
+	 * Write NULL for the node's PlanPruneOutput which the node's Prep routine
+	 * might write over.
+	 */
+	ExecPrepStorePlanPrepOutput(result, NULL, node);
+
+	switch (nodeTag(node))
+	{
+			/*
+			 * control nodes
+			 */
+		case T_Result:
+			ExecPrepResult((Result *) node, context, result);
+			break;
+		case T_ProjectSet:
+			ExecPrepProjectSet((ProjectSet *) node, context, result);
+			break;
+		case T_RecursiveUnion:
+			ExecPrepRecursiveUnion((RecursiveUnion *) node, context, result);
+			break;
+		case T_BitmapAnd:
+			ExecPrepBitmapAnd((BitmapAnd *) node, context, result);
+			break;
+		case T_BitmapOr:
+			ExecPrepBitmapOr((BitmapOr *) node, context, result);
+			break;
+		case T_ModifyTable:
+			ExecPrepModifyTable((ModifyTable *) node, context, result);
+			break;
+		case T_Append:
+			ExecPrepAppend((Append *) node, context, result);
+			break;
+		case T_MergeAppend:
+			ExecPrepMergeAppend((MergeAppend *) node, context, result);
+			break;
+
+			/*
+			 * scan nodes
+			 */
+		case T_SeqScan:
+			ExecPrepSeqScan((SeqScan *) node, context, result);
+			break;
+		case T_SampleScan:
+			ExecPrepSampleScan((SampleScan *) node, context, result);
+			break;
+		case T_IndexScan:
+			ExecPrepIndexScan((IndexScan *) node, context, result);
+			break;
+		case T_IndexOnlyScan:
+			ExecPrepIndexOnlyScan((IndexOnlyScan *) node, context, result);
+			break;
+		case T_BitmapIndexScan:
+			ExecPrepBitmapIndexScan((BitmapIndexScan *) node, context, result);
+			break;
+		case T_BitmapHeapScan:
+			ExecPrepBitmapHeapScan((BitmapHeapScan *) node, context, result);
+			break;
+		case T_TidScan:
+			ExecPrepTidScan((TidScan *) node, context, result);
+			break;
+		case T_TidRangeScan:
+			ExecPrepTidRangeScan((TidRangeScan *) node, context, result);
+			break;
+		case T_SubqueryScan:
+			ExecPrepSubqueryScan((SubqueryScan *) node, context, result);
+			break;
+		case T_FunctionScan:
+			ExecPrepFunctionScan((FunctionScan *) node, context, result);
+			break;
+		case T_TableFuncScan:
+			ExecPrepTableFuncScan((TableFuncScan *) node, context, result);
+			break;
+		case T_ValuesScan:
+			ExecPrepValuesScan((ValuesScan *) node, context, result);
+			break;
+		case T_CteScan:
+			ExecPrepCteScan((CteScan *) node, context, result);
+			break;
+		case T_NamedTuplestoreScan:
+			ExecPrepNamedTuplestoreScan((NamedTuplestoreScan *) node, context, result);
+			break;
+		case T_WorkTableScan:
+			ExecPrepWorkTableScan((WorkTableScan *) node, context, result);
+			break;
+		case T_ForeignScan:
+			ExecPrepForeignScan((ForeignScan *) node, context, result);
+			break;
+		case T_CustomScan:
+			ExecPrepCustomScan((CustomScan *) node, context, result);
+			break;
+
+			/*
+			 * join nodes: subnodes handled below
+			 */
+		case T_NestLoop:
+			ExecPrepNestLoop((NestLoop *) node, context, result);
+			break;
+		case T_MergeJoin:
+			ExecPrepMergeJoin((MergeJoin *) node, context, result);
+			break;
+		case T_HashJoin:
+			ExecPrepHashJoin((HashJoin *) node, context, result);
+			break;
+
+			/*
+			 * materialization nodes: subnodes handled below
+			 */
+		case T_Material:
+			ExecPrepMaterial((Material *) node, context, result);
+			break;
+		case T_Sort:
+			ExecPrepSort((Sort *) node, context, result);
+			break;
+		case T_IncrementalSort:
+			ExecPrepIncrementalSort((IncrementalSort *) node, context, result);
+			break;
+		case T_Memoize:
+			ExecPrepMemoize((Memoize *) node, context, result);
+			break;
+		case T_Group:
+			ExecPrepGroup((Group *) node, context, result);
+			break;
+		case T_Agg:
+			ExecPrepAgg((Agg *) node, context, result);
+			break;
+		case T_WindowAgg:
+			ExecPrepWindowAgg((WindowAgg *) node, context, result);
+			break;
+		case T_Unique:
+			ExecPrepUnique((Unique *) node, context, result);
+			break;
+		case T_Gather:
+			ExecPrepGather((Gather *) node, context, result);
+			break;
+		case T_GatherMerge:
+			ExecPrepGatherMerge((GatherMerge *) node, context, result);
+			break;
+		case T_Hash:
+			ExecPrepHash((Hash *) node, context, result);
+			break;
+		case T_SetOp:
+			ExecPrepSetOp((SetOp *) node, context, result);
+			break;
+		case T_LockRows:
+			ExecPrepLockRows((LockRows *) node, context, result);
+			break;
+		case T_Limit:
+			ExecPrepLimit((Limit *) node, context, result);
+			break;
+
+		default:
+			elog(ERROR, "unrecognized node type: %d", (int) nodeTag(node));
+			result = NULL;		/* keep compiler quiet */
+			break;
+	}
+
+	/*
+	 * Prep any initPlans present in this node.  The planner put them in
+	 * a separate list for us.
+	 */
+	foreach(l, node->initPlan)
+	{
+		SubPlan    *subplan = (SubPlan *) lfirst(l);
+
+		Assert(IsA(subplan, SubPlan));
+		ExecPrepSubPlan(subplan, context, result);
+	}
+}
+
 /* ------------------------------------------------------------------------
  *		ExecInitNode
  *
@@ -157,6 +360,9 @@ ExecInitNode(Plan *node, EState *estate, int eflags)
 	 */
 	check_stack_depth();
 
+	/* Check that the PlanPrepOutput for the node looks sane if any. */
+	EXEC_PREP_OUTPUT_SANITY(node, estate);
+
 	switch (nodeTag(node))
 	{
 			/*
diff --git a/src/backend/executor/execUtils.c b/src/backend/executor/execUtils.c
index 9df1f81ea8..5c85148b37 100644
--- a/src/backend/executor/execUtils.c
+++ b/src/backend/executor/execUtils.c
@@ -119,6 +119,7 @@ CreateExecutorState(void)
 	estate->es_relations = NULL;
 	estate->es_rowmarks = NULL;
 	estate->es_plannedstmt = NULL;
+	estate->es_execprep = NULL;
 
 	estate->es_junkFilter = NULL;
 
@@ -785,6 +786,13 @@ ExecGetRangeTableRelation(EState *estate, Index rti)
 
 	Assert(rti > 0 && rti <= estate->es_range_table_size);
 
+	/*
+	 * A cross-check that AcquireExecutorLocks() hasn't missed any relations
+	 * it must not have.
+	 */
+	Assert(estate->es_execprep == NULL ||
+		   bms_is_member(rti, estate->es_execprep->relationRTIs));
+
 	rel = estate->es_relations[rti - 1];
 	if (rel == NULL)
 	{
diff --git a/src/backend/executor/functions.c b/src/backend/executor/functions.c
index 29a68879ee..5f0ff2df2a 100644
--- a/src/backend/executor/functions.c
+++ b/src/backend/executor/functions.c
@@ -844,7 +844,7 @@ postquel_start(execution_state *es, SQLFunctionCachePtr fcache)
 	else
 		dest = None_Receiver;
 
-	es->qd = CreateQueryDesc(es->stmt,
+	es->qd = CreateQueryDesc(es->stmt, NULL,
 							 fcache->src,
 							 GetActiveSnapshot(),
 							 InvalidSnapshot,
diff --git a/src/backend/executor/nodeAgg.c b/src/backend/executor/nodeAgg.c
index 08cf569d8f..f3b0ec75d3 100644
--- a/src/backend/executor/nodeAgg.c
+++ b/src/backend/executor/nodeAgg.c
@@ -3142,6 +3142,19 @@ hashagg_reset_spill_state(AggState *aggstate)
 	}
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepAgg
+ *
+ *		This "preps" the Agg node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepAgg(Agg *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 
 /* -----------------
  * ExecInitAgg
diff --git a/src/backend/executor/nodeAppend.c b/src/backend/executor/nodeAppend.c
index 7937f1c88f..a44c8079bd 100644
--- a/src/backend/executor/nodeAppend.c
+++ b/src/backend/executor/nodeAppend.c
@@ -62,6 +62,7 @@
 #include "executor/execPartition.h"
 #include "executor/nodeAppend.h"
 #include "miscadmin.h"
+#include "partitioning/partdesc.h"
 #include "pgstat.h"
 #include "storage/latch.h"
 
@@ -94,6 +95,62 @@ static bool ExecAppendAsyncRequest(AppendState *node, TupleTableSlot **result);
 static void ExecAppendAsyncEventWait(AppendState *node);
 static void classify_matching_subplans(AppendState *node);
 
+/* ----------------------------------------------------------------
+ *		ExecPrepAppend
+ *
+ *		Prep an append node
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepAppend(Append *node, ExecPrepContext *context,
+			   ExecPrepOutput *result)
+{
+	PartitionPruneInfo *pruneinfo = node->part_prune_info;
+
+	if (pruneinfo && pruneinfo->contains_init_steps)
+	{
+		List	   *rtable = context->stmt->rtable;
+		List	   *subplans = node->appendplans;
+		ParamListInfo params = context->params;
+		Bitmapset  *parentrelids;
+		int			i;
+		PlanPrepOutput *planPrepResult = makeNode(PlanPrepOutput);
+
+		planPrepResult->plan_node_id = node->plan.plan_node_id;
+		planPrepResult->initially_valid_subnodes =
+			ExecPrepDoInitialPruning(pruneinfo, rtable, params, &parentrelids);
+		/* Replace the NULL that ExecPrepNode() would've written. */
+		ExecPrepStorePlanPrepOutput(result, planPrepResult, &node->plan);
+
+		/* All relevant parents must be reported too. */
+		Assert(bms_num_members(parentrelids) > 0);
+		result->relationRTIs = bms_add_members(result->relationRTIs,
+											   parentrelids);
+
+		/* And all leaf partitions that will be scanned. */
+		i = -1;
+		while ((i = bms_next_member(planPrepResult->initially_valid_subnodes, i)) >= 0)
+		{
+			Plan   *subplan = list_nth(subplans, i);
+
+			ExecPrepNode(subplan, context, result);
+		}
+	}
+	else
+	{
+		List	   *subplans = node->appendplans;
+		ListCell   *lc;
+
+		/* Recurse to prep *all* of the node's child subplans. */
+		foreach(lc, subplans)
+		{
+			Plan *subplan = (Plan *) lfirst(lc);
+
+			ExecPrepNode(subplan, context, result);
+		}
+	}
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitAppend
  *
@@ -136,39 +193,19 @@ ExecInitAppend(Append *node, EState *estate, int eflags)
 	/* If run-time partition pruning is enabled, then set that up now */
 	if (node->part_prune_info != NULL)
 	{
-		PartitionPruneState *prunestate;
-
-		/* We may need an expression context to evaluate partition exprs */
-		ExecAssignExprContext(estate, &appendstate->ps);
-
-		/* Create the working data structure for pruning. */
-		prunestate = ExecCreatePartitionPruneState(&appendstate->ps,
-												   node->part_prune_info);
-		appendstate->as_prune_state = prunestate;
-
-		/* Perform an initial partition prune, if required. */
-		if (prunestate->do_initial_prune)
-		{
-			/* Determine which subplans survive initial pruning */
-			validsubplans = ExecFindInitialMatchingSubPlans(prunestate,
-															list_length(node->appendplans));
-
-			nplans = bms_num_members(validsubplans);
-		}
-		else
-		{
-			/* We'll need to initialize all subplans */
-			nplans = list_length(node->appendplans);
-			Assert(nplans > 0);
-			validsubplans = bms_add_range(NULL, 0, nplans - 1);
-		}
+		validsubplans = ExecInitPartitionPruning(&appendstate->ps,
+												 list_length(node->appendplans),
+												 node->part_prune_info,
+												 &appendstate->as_prune_state);
+		nplans = bms_num_members(validsubplans);
 
 		/*
 		 * When no run-time pruning is required and there's at least one
 		 * subplan, we can fill as_valid_subplans immediately, preventing
 		 * later calls to ExecFindMatchingSubPlans.
 		 */
-		if (!prunestate->do_exec_prune && nplans > 0)
+		if (appendstate->as_prune_state == NULL ||
+			(!appendstate->as_prune_state->do_exec_prune && nplans > 0))
 			appendstate->as_valid_subplans = bms_add_range(NULL, 0, nplans - 1);
 	}
 	else
diff --git a/src/backend/executor/nodeBitmapAnd.c b/src/backend/executor/nodeBitmapAnd.c
index b54c79f853..4ad3e5ff81 100644
--- a/src/backend/executor/nodeBitmapAnd.c
+++ b/src/backend/executor/nodeBitmapAnd.c
@@ -45,6 +45,24 @@ ExecBitmapAnd(PlanState *pstate)
 	return NULL;
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepBitmapAnd
+ *
+ *		This "preps" the BitmapAnd node and the subplans.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepBitmapAnd(BitmapAnd *node, ExecPrepContext *context,
+				  ExecPrepOutput *result)
+{
+	ListCell *lc;
+
+	foreach(lc, node->bitmapplans)
+	{
+		ExecPrepNode((Plan *) lfirst(lc), context, result);
+	}
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitBitmapAnd
  *
diff --git a/src/backend/executor/nodeBitmapHeapscan.c b/src/backend/executor/nodeBitmapHeapscan.c
index f6fe07ad70..aaf215a4cc 100644
--- a/src/backend/executor/nodeBitmapHeapscan.c
+++ b/src/backend/executor/nodeBitmapHeapscan.c
@@ -696,6 +696,20 @@ ExecEndBitmapHeapScan(BitmapHeapScanState *node)
 	table_endscan(scanDesc);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepBitmapHeapScan
+ *
+ *		This "preps" the BitmapHeapScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepBitmapHeapScan(BitmapHeapScan *node, ExecPrepContext *context,
+					   ExecPrepOutput *result)
+{
+	result->relationRTIs = bms_add_member(result->relationRTIs,
+										  node->scan.scanrelid);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitBitmapHeapScan
  *
diff --git a/src/backend/executor/nodeBitmapIndexscan.c b/src/backend/executor/nodeBitmapIndexscan.c
index 551e47630d..bb766f71a2 100644
--- a/src/backend/executor/nodeBitmapIndexscan.c
+++ b/src/backend/executor/nodeBitmapIndexscan.c
@@ -201,6 +201,20 @@ ExecEndBitmapIndexScan(BitmapIndexScanState *node)
 		index_close(indexRelationDesc, NoLock);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepBitmapIndexScan
+ *
+ *		This "preps" the BitmapIndexScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepBitmapIndexScan(BitmapIndexScan *node, ExecPrepContext *context,
+						ExecPrepOutput *result)
+{
+	result->relationRTIs = bms_add_member(result->relationRTIs,
+										  node->scan.scanrelid);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitBitmapIndexScan
  *
diff --git a/src/backend/executor/nodeBitmapOr.c b/src/backend/executor/nodeBitmapOr.c
index 2d57f11fe7..feb3e4a8d6 100644
--- a/src/backend/executor/nodeBitmapOr.c
+++ b/src/backend/executor/nodeBitmapOr.c
@@ -46,6 +46,24 @@ ExecBitmapOr(PlanState *pstate)
 	return NULL;
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepBitmapOr
+ *
+ *		This "preps" the BitmapOr node and the subplans.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepBitmapOr(BitmapOr *node, ExecPrepContext *context,
+				 ExecPrepOutput *result)
+{
+	ListCell *lc;
+
+	foreach(lc, node->bitmapplans)
+	{
+		ExecPrepNode((Plan *) lfirst(lc), context, result);
+	}
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitBitmapOr
  *
diff --git a/src/backend/executor/nodeCtescan.c b/src/backend/executor/nodeCtescan.c
index b9d7dec8a2..533cfb7874 100644
--- a/src/backend/executor/nodeCtescan.c
+++ b/src/backend/executor/nodeCtescan.c
@@ -166,6 +166,18 @@ ExecCteScan(PlanState *pstate)
 					(ExecScanRecheckMtd) CteScanRecheck);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepCteScan
+ *
+ *		This "preps" the CteScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepCteScan(CteScan *node, ExecPrepContext *context,
+				ExecPrepOutput *result)
+{
+	/* nothing to do */
+}
 
 /* ----------------------------------------------------------------
  *		ExecInitCteScan
diff --git a/src/backend/executor/nodeCustom.c b/src/backend/executor/nodeCustom.c
index 8f56bd8a23..0bf1636326 100644
--- a/src/backend/executor/nodeCustom.c
+++ b/src/backend/executor/nodeCustom.c
@@ -24,6 +24,24 @@
 
 static TupleTableSlot *ExecCustomScan(PlanState *pstate);
 
+/* ----------------------------------------------------------------
+ *		ExecPrepCustomScan
+ *
+ *		This "preps" the CustomScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepCustomScan(CustomScan *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	ListCell *lc;
+
+	result->relationRTIs = bms_add_members(result->relationRTIs,
+										   node->custom_relids);
+	foreach(lc, node->custom_plans)
+	{
+		ExecPrepNode((Plan *) lfirst(lc), context, result);
+	}
+}
 
 CustomScanState *
 ExecInitCustomScan(CustomScan *cscan, EState *estate, int eflags)
diff --git a/src/backend/executor/nodeForeignscan.c b/src/backend/executor/nodeForeignscan.c
index 5b9737c2ab..ffe17ec6d5 100644
--- a/src/backend/executor/nodeForeignscan.c
+++ b/src/backend/executor/nodeForeignscan.c
@@ -134,6 +134,18 @@ ExecForeignScan(PlanState *pstate)
 					(ExecScanRecheckMtd) ForeignRecheck);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepForeignScan
+ *
+ *		This "preps" the ForeignScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepForeignScan(ForeignScan *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	result->relationRTIs = bms_add_members(result->relationRTIs,
+										   node->fs_relids);
+}
 
 /* ----------------------------------------------------------------
  *		ExecInitForeignScan
diff --git a/src/backend/executor/nodeFunctionscan.c b/src/backend/executor/nodeFunctionscan.c
index 434379a5aa..df055ce01f 100644
--- a/src/backend/executor/nodeFunctionscan.c
+++ b/src/backend/executor/nodeFunctionscan.c
@@ -272,6 +272,19 @@ ExecFunctionScan(PlanState *pstate)
 					(ExecScanRecheckMtd) FunctionRecheck);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepFunctionScan
+ *
+ *		This "preps" the FunctionScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepFunctionScan(FunctionScan *node, ExecPrepContext *context,
+					 ExecPrepOutput *result)
+{
+	/* nothing to do*/
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitFunctionScan
  * ----------------------------------------------------------------
diff --git a/src/backend/executor/nodeGather.c b/src/backend/executor/nodeGather.c
index 4f8a17df7d..0edb0ae13a 100644
--- a/src/backend/executor/nodeGather.c
+++ b/src/backend/executor/nodeGather.c
@@ -49,6 +49,19 @@ static TupleTableSlot *gather_getnext(GatherState *gatherstate);
 static MinimalTuple gather_readnext(GatherState *gatherstate);
 static void ExecShutdownGatherWorkers(GatherState *node);
 
+/* ----------------------------------------------------------------
+ *		ExecPrepGather
+ *
+ *		This "preps" the Gather node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepGather(Gather *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 
 /* ----------------------------------------------------------------
  *		ExecInitGather
diff --git a/src/backend/executor/nodeGatherMerge.c b/src/backend/executor/nodeGatherMerge.c
index a488cc6d8b..c564d4ac25 100644
--- a/src/backend/executor/nodeGatherMerge.c
+++ b/src/backend/executor/nodeGatherMerge.c
@@ -64,6 +64,19 @@ static bool gather_merge_readnext(GatherMergeState *gm_state, int reader,
 								  bool nowait);
 static void load_tuple_array(GatherMergeState *gm_state, int reader);
 
+/* ----------------------------------------------------------------
+ *		ExecPrepGatherMerge
+ *
+ *		This "preps" the GatherMerge node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepGatherMerge(GatherMerge *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitGather
  * ----------------------------------------------------------------
diff --git a/src/backend/executor/nodeGroup.c b/src/backend/executor/nodeGroup.c
index 666d02b58f..0e5bcf89bf 100644
--- a/src/backend/executor/nodeGroup.c
+++ b/src/backend/executor/nodeGroup.c
@@ -151,6 +151,19 @@ ExecGroup(PlanState *pstate)
 	}
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepGroup
+ *
+ *		This "preps" the Group node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepGroup(Group *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 /* -----------------
  * ExecInitGroup
  *
diff --git a/src/backend/executor/nodeHash.c b/src/backend/executor/nodeHash.c
index 4d68a8b97b..d20e14c7fc 100644
--- a/src/backend/executor/nodeHash.c
+++ b/src/backend/executor/nodeHash.c
@@ -344,6 +344,19 @@ MultiExecParallelHash(HashState *node)
 		   BarrierPhase(build_barrier) == PHJ_BUILD_DONE);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepHash
+ *
+ *		This "preps" the hash node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepHash(Hash *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitHash
  *
diff --git a/src/backend/executor/nodeHashjoin.c b/src/backend/executor/nodeHashjoin.c
index 88b870655e..5665c31873 100644
--- a/src/backend/executor/nodeHashjoin.c
+++ b/src/backend/executor/nodeHashjoin.c
@@ -607,6 +607,20 @@ ExecParallelHashJoin(PlanState *pstate)
 	return ExecHashJoinImpl(pstate, true);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepHashJoin
+ *
+ *		This "preps" the HashJoin node and the node's children.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepHashJoin(HashJoin *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the children. */
+	ExecPrepNode(outerPlan(node), context, result);
+	ExecPrepNode(innerPlan(node), context, result);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitHashJoin
  *
diff --git a/src/backend/executor/nodeIncrementalSort.c b/src/backend/executor/nodeIncrementalSort.c
index d6fb56dec7..c1c8fe2af6 100644
--- a/src/backend/executor/nodeIncrementalSort.c
+++ b/src/backend/executor/nodeIncrementalSort.c
@@ -964,6 +964,20 @@ ExecIncrementalSort(PlanState *pstate)
 	return slot;
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepIncrementalSort
+ *
+ *		This "preps" the IncrementalSort node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepIncrementalSort(IncrementalSort *node, ExecPrepContext *context,
+						ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitIncrementalSort
  *
diff --git a/src/backend/executor/nodeIndexonlyscan.c b/src/backend/executor/nodeIndexonlyscan.c
index eb3ddd2943..ccc60c38f5 100644
--- a/src/backend/executor/nodeIndexonlyscan.c
+++ b/src/backend/executor/nodeIndexonlyscan.c
@@ -476,6 +476,20 @@ ExecIndexOnlyRestrPos(IndexOnlyScanState *node)
 	index_restrpos(node->ioss_ScanDesc);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepIndexOnlyScan
+ *
+ *		This "preps" the IndexOnlyScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepIndexOnlyScan(IndexOnlyScan *node, ExecPrepContext *context,
+					  ExecPrepOutput *result)
+{
+	result->relationRTIs = bms_add_member(result->relationRTIs,
+										  node->scan.scanrelid);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitIndexOnlyScan
  *
diff --git a/src/backend/executor/nodeIndexscan.c b/src/backend/executor/nodeIndexscan.c
index a91f135be7..5080abdd9d 100644
--- a/src/backend/executor/nodeIndexscan.c
+++ b/src/backend/executor/nodeIndexscan.c
@@ -885,6 +885,20 @@ ExecIndexRestrPos(IndexScanState *node)
 	index_restrpos(node->iss_ScanDesc);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepIndexScan
+ *
+ *		This "preps" the IndexScan node.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepIndexScan(IndexScan *node, ExecPrepContext *context,
+				  ExecPrepOutput *result)
+{
+	result->relationRTIs = bms_add_member(result->relationRTIs,
+										  node->scan.scanrelid);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitIndexScan
  *
diff --git a/src/backend/executor/nodeLimit.c b/src/backend/executor/nodeLimit.c
index 1b91b123fa..00aa5dd577 100644
--- a/src/backend/executor/nodeLimit.c
+++ b/src/backend/executor/nodeLimit.c
@@ -437,6 +437,19 @@ compute_tuples_needed(LimitState *node)
 	return node->count + node->offset;
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepLimit
+ *
+ *		This "preps" the limit node and	the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepLimit(Limit *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitLimit
  *
diff --git a/src/backend/executor/nodeLockRows.c b/src/backend/executor/nodeLockRows.c
index 1a9dab25dd..9a3d2c5583 100644
--- a/src/backend/executor/nodeLockRows.c
+++ b/src/backend/executor/nodeLockRows.c
@@ -281,6 +281,19 @@ lnext:
 	return slot;
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepLockRows
+ *
+ *		This "preps" the LockRows node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepLockRows(LockRows *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitLockRows
  *
diff --git a/src/backend/executor/nodeMaterial.c b/src/backend/executor/nodeMaterial.c
index 2cb27e0e9a..802bf37ff1 100644
--- a/src/backend/executor/nodeMaterial.c
+++ b/src/backend/executor/nodeMaterial.c
@@ -156,6 +156,19 @@ ExecMaterial(PlanState *pstate)
 	return ExecClearTuple(slot);
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepMaterial
+ *
+ *		This "preps" the Material node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepMaterial(Material *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitMaterial
  * ----------------------------------------------------------------
diff --git a/src/backend/executor/nodeMemoize.c b/src/backend/executor/nodeMemoize.c
index 55cdd5c4d9..eacfd5f3cb 100644
--- a/src/backend/executor/nodeMemoize.c
+++ b/src/backend/executor/nodeMemoize.c
@@ -902,6 +902,19 @@ ExecMemoize(PlanState *pstate)
 	}							/* switch */
 }
 
+/* ----------------------------------------------------------------
+ *		ExecPrepMemoize
+ *
+ *		This "preps" the Memoize node and the node's subplan.
+ * ----------------------------------------------------------------
+ */
+void
+ExecPrepMemoize(Memoize *node, ExecPrepContext *context, ExecPrepOutput *result)
+{
+	/* Nothing to do beside recursing to the subplan. */
+	ExecPrepNode(outerPlan(node), context, result);
+}
+
 MemoizeState *
 ExecInitMemoize(Memoize *node, EState *estate, int eflags)
 {
